                         
/*Server Program*/
#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<errno.h>
#include<string.h>
#include<fcntl.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<arpa/inet.h>
#include<sys/wait.h>
#include<dirent.h>

#define PORT 7000

void sigchld_handler(int s)
{
    while(wait(NULL)>0);
}

struct fileinfo
{
    char filename[30];
    int filesize;
};

int main()
{
    struct sockaddr_in my_addr;     //my address information
    struct sockaddr_in their_addr; //clients address information
    int sin_size;
    struct sigaction sa;
    struct fileinfo info;
    int sockfd,new_fd;
    int yes=1;
    int size;
    int outfile;
    int recvbytes;
    char buffer[512];      
    if((sockfd=socket(AF_INET,SOCK_STREAM,0))==-1)
    {
        perror("socket");
        exit(1);
    }
    if(setsockopt(sockfd,SOL_SOCKET,SO_REUSEADDR, 
&yes,sizeof(int))==-1)
    {
         perror("setsockopt");
         exit(1);
    }
  
   my_addr.sin_family=AF_INET; //host byte order
   my_addr.sin_port=htons(PORT); //short network byte order
 my_addr.sin_addr.s_addr=INADDR_ANY; /*automatically will fill with my ip*/
 memset(&(my_addr.sin_zero),'\0',8); /*zero to the rest of the structure*/
 
 if(bind(sockfd,(struct sockaddr*) &my_addr,sizeof(struct sockaddr))==-1)
   {
       perror("bind");
       exit(1);
   }
 
   if(listen(sockfd,10)==-1)
   {
       perror("listen");
       exit(1);
   }
 
   sa.sa_handler=sigchld_handler; //reap all zombies
   sigemptyset(&sa.sa_mask);
   sa.sa_flags=SA_RESTART;
   if(sigaction(SIGCHLD,&sa,NULL)==-1)
   {
       perror("sigaction");
       exit(1);
   }

   while(1) //main accept() loop
   {
         sin_size=sizeof(struct sockaddr_in);
if((new_fd=accept(sockfd,(struct sockaddr*)&their_addr,(socklen_t*)&sin_size))==-1)
          {
              perror("accept");
              continue;
          }
    printf("server:got connection from %s\n",inet_ntoa(their_addr.sin_addr));
          //begin child process/
         if(!fork())
         {             //this is the child procees
                
             close(sockfd);   //child doesnt need the listener
            // struct fileinfo info;
             
             if(recv(new_fd,(char*)&info,sizeof(info),0)==-1)
             {  
                 printf("Packet fileinfo from server failed.");
                 exit(1);
             }
     
              size=info.filesize;
  printf("Server returned file %s of %d bytes\n",info.filename,info.filesize);
             // int outfile;
              
outfile=open(info.filename,O_WRONLY|O_CREAT|O_TRUNC,S_IRWXU);

              //start receiving datafile
             // int recvbytes;
              //char buffer[512];
         
               while(size)
               {
                   recvbytes=recv(new_fd,buffer,512,0);
                   write(outfile,buffer,recvbytes);
                   size-=recvbytes;
                }
                 //end of ready to recv//
                 close(outfile);
                 exit(0);        
         }//end if 

         close(new_fd); //parent doesnot need this//

     }//end while
     return 0;
}//end main


